searchData={"items":[{"type":"module","title":"EctoOrderable","doc":"Documentation for `EctoOrderable`.","ref":"EctoOrderable.html"},{"type":"function","title":"EctoOrderable.first_order/1","doc":"Returns the ordered index of the first child in the ordered series.","ref":"EctoOrderable.html#first_order/1"},{"type":"function","title":"EctoOrderable.last_order/1","doc":"Returns the ordered index of the last child in the ordered series.","ref":"EctoOrderable.html#last_order/1"},{"type":"function","title":"EctoOrderable.move/2","doc":"Moves an Order item in a set.","ref":"EctoOrderable.html#move/2"},{"type":"function","title":"Options - EctoOrderable.move/2","doc":"* `:between` - Moves to between the items specified by a tuple `{before_id, after_id}`.\n      Either may be `nil`, in the case that there is no previous or next item. If both are `nil`,\n      it is assumed that the item being moved is the only item in the set, and its order will\n      not be changed.\n    * `:direction` - Moves one place in the set, either `:up` or `:down`.","ref":"EctoOrderable.html#move/2-options"},{"type":"function","title":"EctoOrderable.next_order/1","doc":"Returns the next ordered index, should be used for appending children.","ref":"EctoOrderable.html#next_order/1"},{"type":"function","title":"EctoOrderable.sibling_after/1","doc":"Returns the sibling immediately after an item in the set, `nil` if there is none.","ref":"EctoOrderable.html#sibling_after/1"},{"type":"function","title":"EctoOrderable.sibling_before/1","doc":"Returns the sibling immediately before an item in the set, `nil` if there is none.","ref":"EctoOrderable.html#sibling_before/1"},{"type":"behaviour","title":"EctoOrderable.Order","doc":"defmodule TaskOrder do\n      use EctoOrderable.Order,\n        repo: MyApp.Repo,\n        order_field: :order_index,\n        order_increment: 1000.0\n\n      def set_query(organization, opts) do\n        ...\n      end\n\n      def set_query_for_item(task, opts) do\n        ...\n      end\n\n      def item_query(task, opts) do\n        ...\n      end\n    end\n\n    TaskOrder.set(organization) |> EctoOrderable.first_order()\n\n    TaskOrder.set(organization) |> EctoOrderable.last_order()\n\n    TaskOrder.set(organization) |> EctoOrderable.next_order()\n\n    TaskOrder.item(task) |> EctoOrderable.move(:up)\n\n    TaskOrder.item(task) |> EctoOrderable.current_order()\n\n    TaskOrder.item(task) |> EctoOrderable.insert(:up)\n\n    TaskOrder.item(task) |> EctoOrderable.reposition(1000.0)\n\n    TaskOrder.item(task) |> EctoOrderable.reposition(1000.0)","ref":"EctoOrderable.Order.html"},{"type":"callback","title":"EctoOrderable.Order.item_query/2","doc":"Given a struct that represents an item in an OrderableSet, must return a query that filters\nfor this specific item in the set.","ref":"EctoOrderable.Order.html#c:item_query/2"},{"type":"type","title":"EctoOrderable.Order.order/0","doc":"","ref":"EctoOrderable.Order.html#t:order/0"},{"type":"callback","title":"EctoOrderable.Order.set_query/2","doc":"Given a struct that represents a container for the set of all items in an OrderableSet,\nmust return a query that filters for all the items in the set.","ref":"EctoOrderable.Order.html#c:set_query/2"},{"type":"callback","title":"EctoOrderable.Order.set_query_for_item/2","doc":"Given a struct that represents an item in an OrderableSet, must return a query that filters\nfor all the items in the set.","ref":"EctoOrderable.Order.html#c:set_query_for_item/2"},{"type":"module","title":"EctoOrderable.Query","doc":"Helpers for querying position information for items in an ordered set.","ref":"EctoOrderable.Query.html"},{"type":"macro","title":"EctoOrderable.Query.first_in_order?/2","doc":"Given an interpolated Orderable and an Ecto query term representing an orderable row,\nreturns a boolean indicating if the row is first in the sequence.","ref":"EctoOrderable.Query.html#first_in_order?/2"},{"type":"macro","title":"EctoOrderable.Query.last_in_order?/2","doc":"Given an interpolated Orderable and an Ecto query term representing an orderable row,\nreturns a boolean indicating if the row is last in the sequence.","ref":"EctoOrderable.Query.html#last_in_order?/2"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}